#!/bin/sh
. `dirname $0`/../../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo 0 > /sys/class/graphics/fbcon/cursor_blink

echo "select resolution"
echo "================="
echo "1 = 2592 x 1944 Full"
echo "2 = 2048 x 1536 QXGA, with ROI"
echo "3 = 1600 x 1200 UXGA, with ROI"
echo "4 = 1280 x 1024 SXGA, with ROI"
echo "5 = 1024 x 768  XGA, with Skip2 and ROI"
echo "6 = 800  x 600  SVGA, with Skip2 and ROI"
#echo "7 = 640  x 480  VGA, with Skip4 and ROI"
echo "8 = 1920 x 1080 FullHD, with ROI"
echo "9 = 1280 x 720  HD, with Skip2 and ROI"
read RESOLUTION
echo "Your select = $RESOLUTION"
case $RESOLUTION in
  "1") SENSOR_RES="2592x1944"; GRAB_RES="2592x1944"; FRAME_SIZE=",width=2592,height=1944"; OFFSET_SENSOR="0,0"; SCALE_SIZE=",width=640,height=480"; CTLS=( -c horizontal_skipping=0 -c vertical_skipping=0 ); KMS_SYNC="true" ;;
  "2") SENSOR_RES="2048x1536"; GRAB_RES="2048x1536"; FRAME_SIZE=",width=2048,height=1536"; OFFSET_SENSOR="272,204"; SCALE_SIZE=",width=680,height=512"; CTLS=( -c horizontal_skipping=0 -c vertical_skipping=0); KMS_SYNC="true" ;;
  "3") SENSOR_RES="1600x1200"; GRAB_RES="1600x1200"; FRAME_SIZE=",width=1600,height=1200"; OFFSET_SENSOR="496,372"; SCALE_SIZE=",width=800,height=600"; CTLS=( -c horizontal_skipping=0 -c vertical_skipping=0); KMS_SYNC="true" ;;
  "4") SENSOR_RES="1280x1024"; GRAB_RES="1280x1024"; FRAME_SIZE=",width=1280,height=1024"; OFFSET_SENSOR="656,460"; SCALE_SIZE=",width=640,height=512"; CTLS=( -c horizontal_skipping=0 -c vertical_skipping=0); KMS_SYNC="true" ;;
  "5") SENSOR_RES="2048x1536"; GRAB_RES="1024x768"; FRAME_SIZE=",width=1024,height=768"; OFFSET_SENSOR="272,204"; SCALE_SIZE=",width=640,height=480"; CTLS=( -c horizontal_skipping=1 -c vertical_skipping=1); KMS_SYNC="true" ;;
  "6") SENSOR_RES="1600x1200"; GRAB_RES="800x600"; FRAME_SIZE=",width=800,height=600"; OFFSET_SENSOR="496,272"; SCALE_SIZE=",width=640,height=480"; CTLS=( -c horizontal_skipping=1 -c vertical_skipping=1); KMS_SYNC="true"  ;;
#  "7") SENSOR_RES="2560x1920"; GRAB_RES="640x480"; FRAME_SIZE=",width=640,height=480"; OFFSET_SENSOR="0,0"; SCALE_SIZE=",width=640,height=480"; CTLS=( -c horizontal_skipping=3 -c vertical_skipping=3); KMS_SYNC="true"  ;;
  "8") SENSOR_RES="1920x1080"; GRAB_RES="1920x1080"; FRAME_SIZE=",width=1920,height=1080"; OFFSET_SENSOR="340,432"; SCALE_SIZE=",width=980,height=540"; CTLS=( -c horizontal_skipping=0 -c vertical_skipping=0); KMS_SYNC="true"  ;;
  "9") SENSOR_RES="2592x1944"; GRAB_RES="1280x720"; FRAME_SIZE=",width=1280,height=720"; OFFSET_SENSOR="20,4"; SCALE_SIZE=",width=1280,height=720"; CTLS=( -c horizontal_skipping=1 -c vertical_skipping=1); KMS_SYNC="true"  ;;
  *) SENSOR_RES="2592x1944"; GRAB_RES="2592x1944"; FRAME_SIZE=",width=2592,height=1944"; OFFSET_SENSOR="0,0"; SCALE_SIZE=",width=640,height=480"; CTLS=( -c horizontal_skipping=0 -c vertical_skipping=0 ); KMS_SYNC="true" ;;
esac

#GLOBAL SCALE_SIZE
#SCALE_SIZE=",width=960,height=720"

echo "starting gstreamer with $CAM_BW_FMT Source ..."
echo "read $FRAME_SIZE (offset x,y=$OFFSET_SENSOR) and write scaled to framebuffer $SCALE_SIZE"
echo "=============================================================="
echo ""
echo "configure IPU1_CSI0 (camera_0 port) with media_control"
echo "======================================================"

media-ctl -r
media-ctl -l ''$CAM_ENTITY_NUMBER'1 -> "imx6-mipi-csi2":0 [1]'
media-ctl -l "'imx6-mipi-csi2':1->'ipu1_csi0_mux':0 [1]"
media-ctl -l "'ipu1_csi0_mux':2->'ipu1_csi0':0 [1]"
media-ctl -l "'ipu1_csi0':2->'ipu1_csi0 capture':0 [1]"
#           Camera -> iMX6-mipi-csi2 -> IPU1_CSI0_mux -> IPU1-CSI0 -> IPU1-CSI0 capture (/dev/videoX)  

media-ctl -V ''$CAM_ENTITY_NUMBER'1 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' ('$OFFSET_SENSOR')/'$SENSOR_RES']'
media-ctl -V '"imx6-mipi-csi2":0 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'
media-ctl -V '"imx6-mipi-csi2":1 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'
media-ctl -V '"ipu1_csi0_mux":1 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'
media-ctl -V '"ipu1_csi0_mux":2 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'
media-ctl -V '"ipu1_csi0":0 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'
media-ctl -V '"ipu1_csi0":2 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'

echo ""
echo " configure camera with v4l2_control"
echo " =================================="


$V4L2_CTRL_CAM0
v4l2-ctl "${CTLS[@]}" -d "$IPU1_CSI0_DEVICE"

echo ""
echo "start gstreamer, break with ctl-C"
echo "================================="

gst-launch-1.0 \
	v4l2src device=$IPU1_CSI0_DEVICE ! \
	video/x-raw,format=GRAY8,depth=8$FRAME_SIZE ! \
	videoscale ! \
	video/x-raw$SCALE_SIZE ! \
	videoconvert ! \
	queue ! kmssink driver-name="imx-drm" force-modesetting=false can-scale=false sync=$KMS_SYNC
#	fbdevsink sync=false

#	i2c file=`dirname $0`/../register-settings-ar052x.txt show=0 dev=$CAM_DEVICE ! \
#	Use the i2s plugin only for special register settings, that are not available through v4l2_control.

CTLS=( -c horizontal_skipping=0 -c vertical_skipping=0 )
v4l2-ctl "${CTLS[@]}" -d "$IPU1_CSI0_DEVICE"

echo 1 > /sys/class/graphics/fbcon/cursor_blink